/* nexus_warhead_bugOff.js */

/*
------------------------
JSHINT: Options
------------------------
*/

/*jshint esversion: 6*/
/*jshint sub:true*/


this.name			= "nexus_warhead_bugOff";
this.author			= "UK_Eliter";
this.description	= "Script for Nexus BugOff warhead";
this.copyright		= "2014 Creative Commons: attribution, non-commercial, sharealike.";
this.licence		= "CC-NC-SA 3";

// Associated AI	nexus_warheadAI.PLIST


/*
--------------
DEBUG SWTICHES
---------------
*/
//this.logging = true; // THIS SHOULD BE COMMENTED OUT WHEN NOT TESTING
//this.debug = false;


/*
------------------------
JSHINT: start of wrapper
------------------------
*/

(function(){
"use strict";


/*
---------
MAIN CODE
---------
*/

this.$isBug = function(e) {
	return e.isShip && e.isThargoid;
};


this.$detonate = function() {
	// Called only by AI.
	var i;
	var s;

	// Deal special damage to anything thargoid.
	s = system.filteredEntities(this, this.$isBug, this.ship, 150);
	i = s.length;
	while ( i-- ) {
		if ( s[i] && s[i].isValid ) {
			s[i].energy -= 65;
		}
	}

	// Deal generic damage.
	this.ship.dealEnergyDamage(140, 30, 0.25);
	// function dealEnergyDamage(damage : Number, idealRange : Number [, velocityBias : Number])
	// The standard Oolite missile uses dealEnergyDamage(170, 32.5, 0.25), has a maximum speed of 0.75LM, and its AI tries to detonate it 25m from its target. [NB: If target within ideal range, takes full damage.]
	
	this.ship.explode();
};


/*
----------------------
JSHINT: end of wrapper
----------------------
*/

}).call(this);


// EOF
